import { List, String } from 'ts-toolbelt';
declare type SplitByDelimiter<S extends string, TChar extends string> = String.Join<List.Filter<String.Split<S, TChar>, ''>, '_'>;
declare type NormalizeKey<S extends string> = (SplitByDelimiter<SplitByDelimiter<SplitByDelimiter<SplitByDelimiter<S, '-'>, '.'>, '_'>, ' '>);
/**
 * @private
 */
declare type ToCamelCaseInternal<S extends string> = S extends `${infer H}_${infer Tail}` ? `${H}${Capitalize<ToCamelCaseInternal<Tail>>}` : S;
export declare type ToCamelCase<T extends string> = ToCamelCaseInternal<NormalizeKey<T>> extends '' ? never : ToCamelCaseInternal<NormalizeKey<T>>;
export declare type CamelCased<TMap extends Record<PropertyKey, PropertyKey>, TData> = {
    [P in keyof TData as P extends keyof TMap ? TMap[P] : P extends string ? ToCamelCase<P> : P]: TData[P];
};
export {};
